package org.bench4q.web.TestPlan;

import java.util.Map;
import java.util.UUID;

import javax.xml.bind.JAXBException;

import org.bench4q.share.enums.master.TestPlanStatus;
import org.bench4q.share.models.master.TestPlanBusinessModel;
import org.bench4q.share.models.master.TestPlanDBModel;
import org.bench4q.share.models.master.TestPlanResultModel;
import org.bench4q.web.exception.CustomGenericException;
import org.bench4q.web.extractObjectFromXml.ObjectXmlExchange;
import org.bench4q.web.service.BaseService;
import org.bench4q.web.service.CommunicateWithMaster;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
@Component
public class TestPlanInfo {
	private CommunicateWithMaster communicateWithMaster;
	private String baseUrl=BaseService.getMasterIP()+"testPlan";
	private CommunicateWithMaster getCommunicateWithMaster() {
		return communicateWithMaster;
	}

	@Autowired
	private void setCommunicateWithMaster(
			CommunicateWithMaster communicateWithMaster) {
		this.communicateWithMaster = communicateWithMaster;
	}

	public TestPlanResultModel getRunningTestPlanModel(String accessToken,
			String testPlanId, String caller) throws CustomGenericException {
		String url = this.baseUrl + "/getRunningInfo";
		caller = "getRunningTestPlanModel";
		Map<String, String> params = BaseService.makeParamsMap("testPlanId",
				testPlanId);
		return (TestPlanResultModel) this.getCommunicateWithMaster()
				.getResponseModel(accessToken, url, TestPlanResultModel.class,
						params, caller);
	}

	public TestPlanResultModel getTestPlanInfoFromDB(
			 String accessToken,
			 String testPlanId,String caller) throws CustomGenericException,
			JAXBException {
		caller =caller+ "_getTestPlanInfo";
		String url = this.baseUrl + "/queryTestPlan/" + testPlanId;
		TestPlanDBModel testPlanDBModel = (TestPlanDBModel) this
				.getCommunicateWithMaster().getResponseModel(accessToken, url,
						TestPlanDBModel.class, null, caller);
		TestPlanBusinessModel testPlanBusinessModel = (TestPlanBusinessModel) ObjectXmlExchange
				.fromXml(TestPlanBusinessModel.class,
						testPlanDBModel.getTestPlanModelContent());
		TestPlanResultModel testPlanResultModel = new TestPlanResultModel();
		testPlanResultModel.setTestPlanId(UUID.fromString(testPlanId));
		testPlanResultModel.setMonitorModels(testPlanBusinessModel
				.getMonitorModels());
		testPlanResultModel.setRunningScriptModels(testPlanBusinessModel
				.getRunningScriptModels());
		testPlanResultModel.setCurrentStatus(TestPlanStatus
				.valueOf(testPlanDBModel.getCurrentStatus()));
		return testPlanResultModel;
	}
}
