package org.bench4q.web.api;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import org.bench4q.share.communication.HttpRequester;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public abstract class BaseControllerService {
	private HttpRequester httpRequester;
	protected final int NETWORKERROR = 1;
	protected final int DOMAINERROR = 2;
	public static String SUCCESS = "success";
	public static String FAIL = "fail";
	public static String httpResponseNull = "http response is null";
	public static String FAIL_WITH_EXCEPTION = "fail with exception";
	protected String masterIP;
	protected final String AUTH_HEADER_PROPERTY = "Authorization";
	protected final String ACCES_TOCKEN_STARTER = "Bearer ";
	protected final int monitorPort = 5556;
	protected final String CONFIG_FILE_NAME = "ipConfig.properties";

	public static final Properties prop = new Properties();

	public BaseControllerService() {
		String masterIpFilePath;
		try {
			masterIpFilePath = BaseControllerService.class.getClassLoader()
					.getResource("").toURI().getPath()
					+ CONFIG_FILE_NAME;
			FileInputStream inputStream = new FileInputStream(new File(
					masterIpFilePath));
			prop.load(inputStream);
			inputStream.close();
			this.masterIP = prop.getProperty("masterAddress") + "/";
		} catch (URISyntaxException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public HttpRequester getHttpRequester() {
		return httpRequester;
	}

	@Autowired
	public void setHttpRequester(HttpRequester httpRequester) {
		this.httpRequester = httpRequester;
	}

	public String getMasterIP() {
		return masterIP;
	}

	public Map<String, String> makeAccessTockenMap(String accessToken) {
		Map<String, String> properties = new HashMap<String, String>();
		properties
				.put(AUTH_HEADER_PROPERTY, ACCES_TOCKEN_STARTER + accessToken);
		return properties;
	}

	public Map<String, String> makeParamsMap(String key, String value) {
		Map<String, String> params = new HashMap<String, String>();
		params.put(key, value);
		return params;
	}

	public Boolean validateInput(String input) {
		if (input == null || input.equals("")) {
			System.err.println("input is invalidate");
			return false;
		} else
			return true;
	}

	public String generateUrl(String[] pathValues, String hostName, String port) {
		String url = hostName + port;
		for (String pathValue : pathValues) {
			url += "/" + pathValue;
		}
		return url;
	}

}
