package org.bench4q.web.exception;

import org.apache.log4j.Logger;
import org.bench4q.web.model.BaseResponseModel;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

@ControllerAdvice
public class GlobalExceptionController {
	private Logger logger = Logger.getLogger(GlobalExceptionController.class);

	@ExceptionHandler(CustomGenericException.class)
	@ResponseBody
	public ExceptionResponseModel handleCustomException(
			CustomGenericException ex) {
		logger.info("caller:"+ex.getSource()+","+ex.getErrorMessage());
		ExceptionResponseModel responseModel = new ExceptionResponseModel(
				ex.getErrorCode(), ex.getErrorMessage(), ex.getSource());
		return responseModel;
	}

	// 处理所有异常，自定义异常之外的异常都执行到这里.

	@ExceptionHandler(Exception.class)
	public BaseResponseModel handleAllException(Exception ex) {

		logger.info(ex.getCause());
		logger.info(ex.getMessage());
		BaseResponseModel responseModel = new BaseResponseModel(false,
				ex.getMessage());
		return responseModel;

	}

}
