package org.bench4q.web.service;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.bench4q.web.api.BaseControllerService;
import org.bench4q.web.model.ResultInfoModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class BaseService {
	protected final int monitorPort = 5556;
	protected CommunicateWithMaster communicateWithMaster;
	private static String CONFIG_FILE_NAME = "ipConfig.properties";
	protected static String masterIP;
	public static final Properties prop = new Properties();

	static {
		String masterIpFilePath;
		try {
			masterIpFilePath = BaseControllerService.class.getClassLoader()
					.getResource("").toURI().getPath()
					+ CONFIG_FILE_NAME;
			FileInputStream inputStream = new FileInputStream(new File(
					masterIpFilePath));
			prop.load(inputStream);
			inputStream.close();
			masterIP = prop.getProperty("masterAddress") + "/";
		} catch (URISyntaxException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	public BaseService() {	

	}

	public static String getMasterIP() {
		return masterIP;
	}

	public String getCONFIG_FILE_NAME() {
		return CONFIG_FILE_NAME;
	}

	public CommunicateWithMaster getCommunicateWithMaster() {
		return communicateWithMaster;
	}

	@Autowired
	public void setCommunicateWithMaster(
			CommunicateWithMaster communicateWithMaster) {
		this.communicateWithMaster = communicateWithMaster;
	}

	public static Map<String, String> makeParamsMap(String key, String value) {
		Map<String, String> params = new HashMap<String, String>();
		params.put(key, value);
		return params;
	}
	public  ResultInfoModel getResultInfoModel(String result, String[] fields) {
		ResultInfoModel resultInfoModel = new ResultInfoModel();
		resultInfoModel.setResult(result);
		if (fields.length <= 0)
			return resultInfoModel;

		resultInfoModel.setChildResults(new ArrayList<ResultInfoModel>());
		for (String field : fields) {
			ResultInfoModel scriptResultInfoModelChild = new ResultInfoModel();

			scriptResultInfoModelChild.setResult(field);
			resultInfoModel.getChildResults().add(scriptResultInfoModelChild);
		}
		return resultInfoModel;
	}

}
