package org.bench4q.web.service;

import java.util.List;
import org.bench4q.share.models.master.OperateScriptServerResponseModel;
import org.bench4q.share.models.master.ScriptModel;
import org.bench4q.web.exception.CustomGenericException;
import org.bench4q.web.model.BaseResponseModel;
import org.springframework.stereotype.Component;

@Component
public class ScriptService extends BaseService {
	private String baseUrl = BaseService.getMasterIP() + "RecordScript";

	public String getBaseUrl() {
		return baseUrl;
	}

	public void setBaseUrl(String baseUrl) {
		this.baseUrl = baseUrl;
	}

	public BaseResponseModel queryScript(int id, String accessToken)
			throws CustomGenericException {
		// check script id and return throw exception
		String caller = "ScriptService:queryScript";

		OperateScriptServerResponseModel operateScriptServerResponseModel = (OperateScriptServerResponseModel) this.getCommunicateWithMaster()
				.getResponseModel(accessToken, this.getBaseUrl()
						+ "/queryScriptById",
						OperateScriptServerResponseModel.class,
						makeParamsMap("scriptId", String.valueOf(id)), caller);
		if (operateScriptServerResponseModel.isSuccess()) {
			List<ScriptModel> scripts = operateScriptServerResponseModel
					.getScriptModels();
			if (scripts == null || scripts.isEmpty())
				return new BaseResponseModel(false, "data empty");
			else
				return new BaseResponseModel(true, scripts);
		}
		else return new BaseResponseModel(false,operateScriptServerResponseModel.getFailCauseString());
	}
}
